﻿using SecurityDataServices;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;
using System.Web;
using System.Web.Security;
using WebSecurity.Models;

namespace WebSecurity
{
    public class SecurityServices : Interfaces.Security.ICustomAuthentication
    {
        public void Authenticate(string username, string password)
        {
            DataServices ds = new DataServices();

            if (!ds.CheckCredentials(username, password))
                return;

            var authTicket = new FormsAuthenticationTicket(1, username, DateTime.Now,
                                               DateTime.Now.AddSeconds(30), true, "");

            string cookieContents = FormsAuthentication.Encrypt(authTicket);

            var cookie = new HttpCookie(FormsAuthentication.FormsCookieName, cookieContents)
            {
                Expires = authTicket.Expiration,
                Path = FormsAuthentication.FormsCookiePath
            };

            if (HttpContext.Current != null)
            {
                HttpContext.Current.Response.Cookies.Add(cookie);
            }

            return;
        }

        public void CreateCustomPrincipal()
        {
            HttpCookie authCookie = HttpContext.Current.Request.Cookies[FormsAuthentication.FormsCookieName];
            if (authCookie != null)
            {
                FormsAuthenticationTicket authTicket = FormsAuthentication.Decrypt(authCookie.Value);
                var identity = new GenericIdentity(authTicket.Name, "Forms");
                var principal = new CustomPrincipal(identity);
                HttpContext.Current.User = principal;
            }
        }
    }
}
